[![Build Status Master](https://travis-ci.org/ALaDyn/ALaDyn.png?branch=master)](https://travis-ci.org/ALaDyn/ALaDyn "master")
[![Build status](https://ci.appveyor.com/api/projects/status/evol3yvpqqfyxi7p?svg=true)](https://ci.appveyor.com/project/cenit/aladyn-kul79)
[![License: GPL v3](https://img.shields.io/badge/License-GPLv3-blue.svg)](https://www.gnu.org/licenses/gpl-3.0)
[![DOI](https://zenodo.org/badge/doi/10.5281/zenodo.592388.svg)](http://dx.doi.org/10.5281/zenodo.592388)
![GitHub tag (latest SemVer)](https://img.shields.io/github/tag/aladyn/aladyn.svg?label=Latest%20Release)

![ALaDyn Logo](https://raw.githubusercontent.com/ALaDyn/ALaDyn/master/media/logo_small.png)

`ALaDyn` (**A**cceleration by **La**ser and **Dyn**amics of charged particles) is a PIC code firstly described in *ALaDyn: A High-Accuracy PIC code for the Maxwell-Vlasov Equations* by C. Benedetti et al., published on IEEE Transactions on Plasma Science, **36** 4, 1790-1798 (2008) and then again in the update *Charge preserving high order PIC schemes* by P. Londrillo et al., published on Nucl. Instrum. Meth. A, **620** 1, 28-35 (2010). PWFA modules have been presented in *Numerical investigation of beam-driven PWFA in quasi-nonlinear regime* by P. Londrillo et al., published on Nucl. Instrum. Meth. A, **740** (2014).

To date, main usage of the code has been carried on in simulating:

- **L**aser **W**ake**F**ield **A**cceleration (**LWFA** Laser driven),

- **P**lasma **W**ake**F**ield **A**cceleration (**PWFA** Beam driven),

- **T**arget **N**ormal **S**heath **A**cceleration (**TNSA** Interaction with solid targets).

This newer version, in part rewritten from scratch, is released as is, without any warranty, and will be maintained here on GitHub. A new publication is currently underway to describe progresses on this new code. If you use `ALaDyn`, you're kindly required to cite the Zenodo DOI of the latest release: [![DOI](https://zenodo.org/badge/doi/10.5281/zenodo.592388.svg)](http://dx.doi.org/10.5281/zenodo.592388).
